diff --git a/src/backend/optimizer/plan/setrefs.c b/src/backend/optimizer/plan/setrefs.c
index b5c4124..9c08ac0 100644
--- a/src/backend/optimizer/plan/setrefs.c
+++ b/src/backend/optimizer/plan/setrefs.c
@@ -40,6 +40,7 @@ typedef struct
 	List	   *tlist;			/* underlying target list */
 	int			num_vars;		/* number of plain Var tlist entries */
 	bool		has_ph_vars;	/* are there PlaceHolderVar entries? */
+	bool		has_grp_vars;	/* are there GroupedVar entries? */
 	bool		has_non_vars;	/* are there other entries? */
 	bool		has_conv_whole_rows;	/* are there ConvertRowtypeExpr
 										 * entries encapsulating a whole-row
@@ -1196,33 +1197,50 @@ set_foreignscan_references(PlannerInfo *root,
 
 	if (fscan->fdw_scan_tlist != NIL || fscan->scan.scanrelid == 0)
 	{
+		List	   *tlist_tmp;
+		indexed_tlist *itlist = build_tlist_index(fscan->fdw_scan_tlist);
+
 		/*
 		 * Adjust tlist, qual, fdw_exprs, fdw_recheck_quals to reference
-		 * foreign scan tuple
+		 * foreign scan tuple.
+		 *
+		 * Since fdw_scan_tlist contains Aggrefs instead of GroupVars (this is
+		 * convenient for deparsing), the Aggrefs also need to be restored in
+		 * the referencing lists.
+		 *
+		 * XXX Consider thoroughly where tlist_tmp really needs to be used,
+		 * i.e. which of the lists can / cannot contain aggregates.
 		 */
-		indexed_tlist *itlist = build_tlist_index(fscan->fdw_scan_tlist);
-
+		tlist_tmp = restore_grouping_expressions(root,
+												 fscan->scan.plan.targetlist,
+												 true);
 		fscan->scan.plan.targetlist = (List *)
 			fix_upper_expr(root,
-						   (Node *) fscan->scan.plan.targetlist,
+						   (Node *) tlist_tmp,
 						   itlist,
 						   INDEX_VAR,
 						   rtoffset);
+
 		fscan->scan.plan.qual = (List *)
 			fix_upper_expr(root,
 						   (Node *) fscan->scan.plan.qual,
 						   itlist,
 						   INDEX_VAR,
 						   rtoffset);
+
 		fscan->fdw_exprs = (List *)
 			fix_upper_expr(root,
 						   (Node *) fscan->fdw_exprs,
 						   itlist,
 						   INDEX_VAR,
 						   rtoffset);
+
+		tlist_tmp = restore_grouping_expressions(root,
+												 fscan->fdw_recheck_quals,
+												 true);
 		fscan->fdw_recheck_quals = (List *)
 			fix_upper_expr(root,
-						   (Node *) fscan->fdw_recheck_quals,
+						   (Node *) tlist_tmp,
 						   itlist,
 						   INDEX_VAR,
 						   rtoffset);
@@ -1739,9 +1757,81 @@ set_upper_references(PlannerInfo *root, Plan *plan, int rtoffset)
 	indexed_tlist *subplan_itlist;
 	List	   *output_targetlist;
 	ListCell   *l;
+	List	   *sub_tlist_save = NIL;
+
+	if (root->grouped_var_list != NIL)
+	{
+		if (IsA(plan, Agg))
+		{
+			Agg		   *agg = (Agg *) plan;
+
+			if (agg->aggsplit == AGGSPLIT_FINAL_DESERIAL)
+			{
+				/*
+				 * convert_combining_aggrefs could have replaced some vars
+				 * with Aggref expressions representing the partial
+				 * aggregation. We need to restore the same Aggrefs in the
+				 * subplan targetlist, but this would break the subplan if
+				 * it's something else than the partial aggregation (i.e. the
+				 * partial aggregation takes place lower in the plan tree). So
+				 * we'll eventually need to restore the current
+				 * subplan->targetlist.
+				 */
+				if (!IsA(subplan, Agg))
+					sub_tlist_save = subplan->targetlist;
+#ifdef USE_ASSERT_CHECKING
+				else
+					Assert(((Agg *) subplan)->aggsplit == AGGSPLIT_INITIAL_SERIAL);
+#endif							/* USE_ASSERT_CHECKING */
+
+				/*
+				 * Restore the aggregate expressions that we might have
+				 * removed when planning for aggregation at base relation
+				 * level.
+				 */
+				subplan->targetlist =
+					restore_grouping_expressions(root, subplan->targetlist,
+												 true);
+			}
+			else if (agg->aggsplit == AGGSPLIT_INITIAL_SERIAL)
+			{
+				/*
+				 * Partial aggregation node can have GroupedVar's on the input
+				 * if those represent generic (non-Var) grouping expressions.
+				 * Unlike above, the restored expressions should stay there.
+				 */
+				subplan->targetlist =
+					restore_grouping_expressions(root, subplan->targetlist,
+												 true);
+			}
+		}
+		else if (IsA(plan, Result))
+		{
+			/*
+			 * If standalone aggfinalfn function is used (e.g. in the target
+			 * of a Sort node) instead of AGGSPLIT_FINAL_DESERIAL aggregate,
+			 * projection to the aggregate might have been added. Replace the
+			 * function with the aggregate.
+			 *
+			 * TODO Find out if the Result plan is in parallel worker. In that
+			 * case we'd better pass "true" for agg_partial.
+			 */
+			sub_tlist_save = subplan->targetlist;
+			subplan->targetlist =
+				restore_grouping_expressions(root, subplan->targetlist,
+											 false);
+		}
+	}
 
 	subplan_itlist = build_tlist_index(subplan->targetlist);
 
+	/*
+	 * The replacement of GroupVars by Aggrefs was only needed for the index
+	 * build.
+	 */
+	if (sub_tlist_save != NIL)
+		subplan->targetlist = sub_tlist_save;
+
 	output_targetlist = NIL;
 	foreach(l, plan->targetlist)
 	{
@@ -1996,6 +2086,7 @@ build_tlist_index(List *tlist)
 
 	itlist->tlist = tlist;
 	itlist->has_ph_vars = false;
+	itlist->has_grp_vars = false;
 	itlist->has_non_vars = false;
 	itlist->has_conv_whole_rows = false;
 
@@ -2016,6 +2107,8 @@ build_tlist_index(List *tlist)
 		}
 		else if (tle->expr && IsA(tle->expr, PlaceHolderVar))
 			itlist->has_ph_vars = true;
+		else if (tle->expr && IsA(tle->expr, GroupedVar))
+			itlist->has_grp_vars = true;
 		else if (is_converted_whole_row_reference((Node *) tle->expr))
 			itlist->has_conv_whole_rows = true;
 		else
@@ -2299,6 +2392,31 @@ fix_join_expr_mutator(Node *node, fix_join_expr_context *context)
 		/* No referent found for Var */
 		elog(ERROR, "variable not found in subplan target lists");
 	}
+	if (IsA(node, GroupedVar))
+	{
+		GroupedVar *gvar = (GroupedVar *) node;
+
+		/* See if the GroupedVar has bubbled up from a lower plan node */
+		if (context->outer_itlist && context->outer_itlist->has_grp_vars)
+		{
+			newvar = search_indexed_tlist_for_non_var((Expr *) gvar,
+													  context->outer_itlist,
+													  OUTER_VAR);
+			if (newvar)
+				return (Node *) newvar;
+		}
+		if (context->inner_itlist && context->inner_itlist->has_grp_vars)
+		{
+			newvar = search_indexed_tlist_for_non_var((Expr *) gvar,
+													  context->inner_itlist,
+													  INNER_VAR);
+			if (newvar)
+				return (Node *) newvar;
+		}
+
+		/* No referent found for GroupedVar */
+		elog(ERROR, "grouped variable not found in subplan target lists");
+	}
 	if (IsA(node, PlaceHolderVar))
 	{
 		PlaceHolderVar *phv = (PlaceHolderVar *) node;
@@ -2461,7 +2579,8 @@ fix_upper_expr_mutator(Node *node, fix_upper_expr_context *context)
 		/* If no match, just fall through to process it normally */
 	}
 	/* Try matching more complex expressions too, if tlist has any */
-	if (context->subplan_itlist->has_non_vars ||
+	if (context->subplan_itlist->has_grp_vars ||
+		context->subplan_itlist->has_non_vars ||
 		(context->subplan_itlist->has_conv_whole_rows &&
 		 is_converted_whole_row_reference(node)))
 	{
diff --git a/src/backend/optimizer/prep/prepjointree.c b/src/backend/optimizer/prep/prepjointree.c
index 1d7e499..710f028 100644
--- a/src/backend/optimizer/prep/prepjointree.c
+++ b/src/backend/optimizer/prep/prepjointree.c
@@ -911,6 +911,7 @@ pull_up_simple_subquery(PlannerInfo *root, Node *jtnode, RangeTblEntry *rte,
 	memset(subroot->upper_rels, 0, sizeof(subroot->upper_rels));
 	memset(subroot->upper_targets, 0, sizeof(subroot->upper_targets));
 	subroot->processed_tlist = NIL;
+	subroot->max_sortgroupref = 0;
 	subroot->grouping_map = NULL;
 	subroot->minmax_aggs = NIL;
 	subroot->qual_security_level = 0;
diff --git a/src/backend/optimizer/prep/prepunion.c b/src/backend/optimizer/prep/prepunion.c
index f620243..8e4fd0e 100644
--- a/src/backend/optimizer/prep/prepunion.c
+++ b/src/backend/optimizer/prep/prepunion.c
@@ -221,7 +221,7 @@ plan_set_operations(PlannerInfo *root)
 	root->processed_tlist = top_tlist;
 
 	/* Add only the final path to the SETOP upperrel. */
-	add_path(setop_rel, path);
+	add_path(setop_rel, path, false);
 
 	/* Let extensions possibly add some more paths */
 	if (create_upper_paths_hook)
diff --git a/src/backend/optimizer/util/pathnode.c b/src/backend/optimizer/util/pathnode.c
index bc0841b..d9d6bd9 100644
--- a/src/backend/optimizer/util/pathnode.c
+++ b/src/backend/optimizer/util/pathnode.c
@@ -26,6 +26,7 @@
 #include "optimizer/planmain.h"
 #include "optimizer/prep.h"
 #include "optimizer/restrictinfo.h"
+/* TODO Remove this if get_grouping_expressions ends up in another module. */
 #include "optimizer/tlist.h"
 #include "optimizer/var.h"
 #include "parser/parsetree.h"
@@ -54,7 +55,12 @@ static List *translate_sub_tlist(List *tlist, int relid);
 static List *reparameterize_pathlist_by_child(PlannerInfo *root,
 								 List *pathlist,
 								 RelOptInfo *child_rel);
-
+static Path *add_grouping_expressions_to_subpath(PlannerInfo *root,
+									Path *subpath,
+									PathTarget *group_exprs);
+static void make_uniquekeys_for_unique_index(PathTarget *reltarget,
+								 IndexOptInfo *index, Path *path);
+static void make_uniquekeys_for_append_path(PlannerInfo *root, Path *path);
 
 /*****************************************************************************
  *		MISC. PATH UTILITIES
@@ -417,8 +423,9 @@ set_cheapest(RelOptInfo *parent_rel)
  * Returns nothing, but modifies parent_rel->pathlist.
  */
 void
-add_path(RelOptInfo *parent_rel, Path *new_path)
+add_path(RelOptInfo *parent_rel, Path *new_path, bool grouped)
 {
+	List	   *pathlist;
 	bool		accept_new = true;	/* unless we find a superior old path */
 	ListCell   *insert_after = NULL;	/* where to insert new item */
 	List	   *new_path_pathkeys;
@@ -435,6 +442,14 @@ add_path(RelOptInfo *parent_rel, Path *new_path)
 	/* Pretend parameterized paths have no pathkeys, per comment above */
 	new_path_pathkeys = new_path->param_info ? NIL : new_path->pathkeys;
 
+	if (!grouped)
+		pathlist = parent_rel->pathlist;
+	else
+	{
+		Assert(parent_rel->gpi != NULL);
+		pathlist = parent_rel->gpi->pathlist;
+	}
+
 	/*
 	 * Loop to check proposed new path against old paths.  Note it is possible
 	 * for more than one old path to be tossed out because new_path dominates
@@ -444,7 +459,7 @@ add_path(RelOptInfo *parent_rel, Path *new_path)
 	 * list cell.
 	 */
 	p1_prev = NULL;
-	for (p1 = list_head(parent_rel->pathlist); p1 != NULL; p1 = p1_next)
+	for (p1 = list_head(pathlist); p1 != NULL; p1 = p1_next)
 	{
 		Path	   *old_path = (Path *) lfirst(p1);
 		bool		remove_old = false; /* unless new proves superior */
@@ -590,8 +605,7 @@ add_path(RelOptInfo *parent_rel, Path *new_path)
 		 */
 		if (remove_old)
 		{
-			parent_rel->pathlist = list_delete_cell(parent_rel->pathlist,
-													p1, p1_prev);
+			pathlist = list_delete_cell(pathlist, p1, p1_prev);
 
 			/*
 			 * Delete the data pointed-to by the deleted cell, if possible
@@ -622,9 +636,14 @@ add_path(RelOptInfo *parent_rel, Path *new_path)
 	{
 		/* Accept the new path: insert it at proper place in pathlist */
 		if (insert_after)
-			lappend_cell(parent_rel->pathlist, insert_after, new_path);
+			lappend_cell(pathlist, insert_after, new_path);
+		else
+			pathlist = lcons(new_path, pathlist);
+
+		if (!grouped)
+			parent_rel->pathlist = pathlist;
 		else
-			parent_rel->pathlist = lcons(new_path, parent_rel->pathlist);
+			parent_rel->gpi->pathlist = pathlist;
 	}
 	else
 	{
@@ -654,8 +673,9 @@ add_path(RelOptInfo *parent_rel, Path *new_path)
 bool
 add_path_precheck(RelOptInfo *parent_rel,
 				  Cost startup_cost, Cost total_cost,
-				  List *pathkeys, Relids required_outer)
+				  List *pathkeys, Relids required_outer, bool grouped)
 {
+	List	   *pathlist;
 	List	   *new_path_pathkeys;
 	bool		consider_startup;
 	ListCell   *p1;
@@ -664,9 +684,18 @@ add_path_precheck(RelOptInfo *parent_rel,
 	new_path_pathkeys = required_outer ? NIL : pathkeys;
 
 	/* Decide whether new path's startup cost is interesting */
-	consider_startup = required_outer ? parent_rel->consider_param_startup : parent_rel->consider_startup;
+	consider_startup = required_outer ? parent_rel->consider_param_startup :
+		parent_rel->consider_startup;
+
+	if (!grouped)
+		pathlist = parent_rel->pathlist;
+	else
+	{
+		Assert(parent_rel->gpi != NULL);
+		pathlist = parent_rel->gpi->pathlist;
+	}
 
-	foreach(p1, parent_rel->pathlist)
+	foreach(p1, pathlist)
 	{
 		Path	   *old_path = (Path *) lfirst(p1);
 		PathKeysComparison keyscmp;
@@ -757,23 +786,32 @@ add_path_precheck(RelOptInfo *parent_rel,
  *	  referenced by partial BitmapHeapPaths.
  */
 void
-add_partial_path(RelOptInfo *parent_rel, Path *new_path)
+add_partial_path(RelOptInfo *parent_rel, Path *new_path, bool grouped)
 {
 	bool		accept_new = true;	/* unless we find a superior old path */
 	ListCell   *insert_after = NULL;	/* where to insert new item */
 	ListCell   *p1;
 	ListCell   *p1_prev;
 	ListCell   *p1_next;
+	List	   *pathlist;
 
 	/* Check for query cancel. */
 	CHECK_FOR_INTERRUPTS();
 
+	if (!grouped)
+		pathlist = parent_rel->partial_pathlist;
+	else
+	{
+		Assert(parent_rel->gpi != NULL);
+		pathlist = parent_rel->gpi->partial_pathlist;
+	}
+
 	/*
 	 * As in add_path, throw out any paths which are dominated by the new
 	 * path, but throw out the new path if some existing path dominates it.
 	 */
 	p1_prev = NULL;
-	for (p1 = list_head(parent_rel->partial_pathlist); p1 != NULL;
+	for (p1 = list_head(pathlist); p1 != NULL;
 		 p1 = p1_next)
 	{
 		Path	   *old_path = (Path *) lfirst(p1);
@@ -827,12 +865,11 @@ add_partial_path(RelOptInfo *parent_rel, Path *new_path)
 		}
 
 		/*
-		 * Remove current element from partial_pathlist if dominated by new.
+		 * Remove current element from pathlist if dominated by new.
 		 */
 		if (remove_old)
 		{
-			parent_rel->partial_pathlist =
-				list_delete_cell(parent_rel->partial_pathlist, p1, p1_prev);
+			pathlist = list_delete_cell(pathlist, p1, p1_prev);
 			pfree(old_path);
 			/* p1_prev does not advance */
 		}
@@ -847,8 +884,8 @@ add_partial_path(RelOptInfo *parent_rel, Path *new_path)
 
 		/*
 		 * If we found an old path that dominates new_path, we can quit
-		 * scanning the partial_pathlist; we will not add new_path, and we
-		 * assume new_path cannot dominate any later path.
+		 * scanning the pathlist; we will not add new_path, and we assume
+		 * new_path cannot dominate any later path.
 		 */
 		if (!accept_new)
 			break;
@@ -858,10 +895,14 @@ add_partial_path(RelOptInfo *parent_rel, Path *new_path)
 	{
 		/* Accept the new path: insert it at proper place */
 		if (insert_after)
-			lappend_cell(parent_rel->partial_pathlist, insert_after, new_path);
+			lappend_cell(pathlist, insert_after, new_path);
+		else
+			pathlist = lcons(new_path, pathlist);
+
+		if (!grouped)
+			parent_rel->partial_pathlist = pathlist;
 		else
-			parent_rel->partial_pathlist =
-				lcons(new_path, parent_rel->partial_pathlist);
+			parent_rel->gpi->partial_pathlist = pathlist;
 	}
 	else
 	{
@@ -882,9 +923,18 @@ add_partial_path(RelOptInfo *parent_rel, Path *new_path)
  */
 bool
 add_partial_path_precheck(RelOptInfo *parent_rel, Cost total_cost,
-						  List *pathkeys)
+						  List *pathkeys, bool grouped)
 {
 	ListCell   *p1;
+	List	   *pathlist;
+
+	if (!grouped)
+		pathlist = parent_rel->partial_pathlist;
+	else
+	{
+		Assert(parent_rel->gpi != NULL);
+		pathlist = parent_rel->gpi->partial_pathlist;
+	}
 
 	/*
 	 * Our goal here is twofold.  First, we want to find out whether this path
@@ -894,10 +944,11 @@ add_partial_path_precheck(RelOptInfo *parent_rel, Cost total_cost,
 	 * final cost computations.  If so, we definitely want to consider it.
 	 *
 	 * Unlike add_path(), we always compare pathkeys here.  This is because we
-	 * expect partial_pathlist to be very short, and getting a definitive
-	 * answer at this stage avoids the need to call add_path_precheck.
+	 * expect partial_pathlist / grouped_pathlist to be very short, and
+	 * getting a definitive answer at this stage avoids the need to call
+	 * add_path_precheck.
 	 */
-	foreach(p1, parent_rel->partial_pathlist)
+	foreach(p1, pathlist)
 	{
 		Path	   *old_path = (Path *) lfirst(p1);
 		PathKeysComparison keyscmp;
@@ -926,7 +977,7 @@ add_partial_path_precheck(RelOptInfo *parent_rel, Cost total_cost,
 	 * completion.
 	 */
 	if (!add_path_precheck(parent_rel, total_cost, total_cost, pathkeys,
-						   NULL))
+						   NULL, grouped))
 		return false;
 
 	return true;
@@ -1259,11 +1310,13 @@ create_append_path(RelOptInfo *rel, List *subpaths, Relids required_outer,
 /*
  * create_merge_append_path
  *	  Creates a path corresponding to a MergeAppend plan, returning the
- *	  pathnode.
+ *	  pathnode. target can be supplied by caller. If NULL is passed, the field
+ *	  is set to rel->reltarget.
  */
 MergeAppendPath *
 create_merge_append_path(PlannerInfo *root,
 						 RelOptInfo *rel,
+						 PathTarget *target,
 						 List *subpaths,
 						 List *pathkeys,
 						 Relids required_outer,
@@ -1276,7 +1329,7 @@ create_merge_append_path(PlannerInfo *root,
 
 	pathnode->path.pathtype = T_MergeAppend;
 	pathnode->path.parent = rel;
-	pathnode->path.pathtarget = rel->reltarget;
+	pathnode->path.pathtarget = target ? target : rel->reltarget;
 	pathnode->path.param_info = get_appendrel_parampathinfo(rel,
 															required_outer);
 	pathnode->path.parallel_aware = false;
@@ -1413,6 +1466,7 @@ create_material_path(RelOptInfo *rel, Path *subpath)
 		subpath->parallel_safe;
 	pathnode->path.parallel_workers = subpath->parallel_workers;
 	pathnode->path.pathkeys = subpath->pathkeys;
+	pathnode->path.uniquekeys = subpath->uniquekeys;
 
 	pathnode->subpath = subpath;
 
@@ -1446,8 +1500,12 @@ create_unique_path(PlannerInfo *root, RelOptInfo *rel, Path *subpath,
 	MemoryContext oldcontext;
 	int			numCols;
 
-	/* Caller made a mistake if subpath isn't cheapest_total ... */
-	Assert(subpath == rel->cheapest_total_path);
+	/*
+	 * Caller made a mistake if subpath isn't cheapest_total (or the cheapest
+	 * grouped).
+	 */
+	Assert(subpath == rel->cheapest_total_path ||
+		   (rel->gpi != NULL && subpath == linitial(rel->gpi->pathlist)));
 	Assert(subpath->parent == rel);
 	/* ... or if SpecialJoinInfo is the wrong one */
 	Assert(sjinfo->jointype == JOIN_SEMI);
@@ -2075,6 +2133,7 @@ calc_non_nestloop_required_outer(Path *outer_path, Path *inner_path)
  * 'restrict_clauses' are the RestrictInfo nodes to apply at the join
  * 'pathkeys' are the path keys of the new join path
  * 'required_outer' is the set of required outer rels
+ * 'target' can be passed to override that of joinrel.
  *
  * Returns the resulting path node.
  */
@@ -2088,7 +2147,8 @@ create_nestloop_path(PlannerInfo *root,
 					 Path *inner_path,
 					 List *restrict_clauses,
 					 List *pathkeys,
-					 Relids required_outer)
+					 Relids required_outer,
+					 PathTarget *target)
 {
 	NestPath   *pathnode = makeNode(NestPath);
 	Relids		inner_req_outer = PATH_REQ_OUTER(inner_path);
@@ -2121,7 +2181,7 @@ create_nestloop_path(PlannerInfo *root,
 
 	pathnode->path.pathtype = T_NestLoop;
 	pathnode->path.parent = joinrel;
-	pathnode->path.pathtarget = joinrel->reltarget;
+	pathnode->path.pathtarget = target == NULL ? joinrel->reltarget : target;
 	pathnode->path.param_info =
 		get_joinrel_parampathinfo(root,
 								  joinrel,
@@ -2179,13 +2239,15 @@ create_mergejoin_path(PlannerInfo *root,
 					  Relids required_outer,
 					  List *mergeclauses,
 					  List *outersortkeys,
-					  List *innersortkeys)
+					  List *innersortkeys,
+					  PathTarget *target)
 {
 	MergePath  *pathnode = makeNode(MergePath);
 
 	pathnode->jpath.path.pathtype = T_MergeJoin;
 	pathnode->jpath.path.parent = joinrel;
-	pathnode->jpath.path.pathtarget = joinrel->reltarget;
+	pathnode->jpath.path.pathtarget = target == NULL ? joinrel->reltarget :
+		target;
 	pathnode->jpath.path.param_info =
 		get_joinrel_parampathinfo(root,
 								  joinrel,
@@ -2230,6 +2292,7 @@ create_mergejoin_path(PlannerInfo *root,
  * 'required_outer' is the set of required outer rels
  * 'hashclauses' are the RestrictInfo nodes to use as hash clauses
  *		(this should be a subset of the restrict_clauses list)
+ * 'target' can be passed to override that of joinrel.
  */
 HashPath *
 create_hashjoin_path(PlannerInfo *root,
@@ -2241,13 +2304,15 @@ create_hashjoin_path(PlannerInfo *root,
 					 Path *inner_path,
 					 List *restrict_clauses,
 					 Relids required_outer,
-					 List *hashclauses)
+					 List *hashclauses,
+					 PathTarget *target)
 {
 	HashPath   *pathnode = makeNode(HashPath);
 
 	pathnode->jpath.path.pathtype = T_HashJoin;
 	pathnode->jpath.path.parent = joinrel;
-	pathnode->jpath.path.pathtarget = joinrel->reltarget;
+	pathnode->jpath.path.pathtarget = target == NULL ? joinrel->reltarget :
+		target;
 	pathnode->jpath.path.param_info =
 		get_joinrel_parampathinfo(root,
 								  joinrel,
@@ -2294,12 +2359,14 @@ create_hashjoin_path(PlannerInfo *root,
  * 'rel' is the parent relation associated with the result
  * 'subpath' is the path representing the source of data
  * 'target' is the PathTarget to be computed
+ * 'force_result' enforces implementation using Result plan.
  */
 ProjectionPath *
 create_projection_path(PlannerInfo *root,
 					   RelOptInfo *rel,
 					   Path *subpath,
-					   PathTarget *target)
+					   PathTarget *target,
+					   bool force_result)
 {
 	ProjectionPath *pathnode = makeNode(ProjectionPath);
 	PathTarget *oldtarget = subpath->pathtarget;
@@ -2316,8 +2383,10 @@ create_projection_path(PlannerInfo *root,
 	pathnode->path.parallel_workers = subpath->parallel_workers;
 	/* Projection does not change the sort order */
 	pathnode->path.pathkeys = subpath->pathkeys;
+	pathnode->path.uniquekeys = subpath->uniquekeys;
 
 	pathnode->subpath = subpath;
+	pathnode->force_result = force_result;
 
 	/*
 	 * We might not need a separate Result node.  If the input plan node type
@@ -2328,8 +2397,9 @@ create_projection_path(PlannerInfo *root,
 	 * Note: in the latter case, create_projection_plan has to recheck our
 	 * conclusion; see comments therein.
 	 */
-	if (is_projection_capable_path(subpath) ||
-		equal(oldtarget->exprs, target->exprs))
+	if (!force_result &&
+		(is_projection_capable_path(subpath) ||
+		 equal(oldtarget->exprs, target->exprs)))
 	{
 		/* No separate Result node needed */
 		pathnode->dummypp = true;
@@ -2399,7 +2469,8 @@ apply_projection_to_path(PlannerInfo *root,
 	 * separate ProjectionPath.
 	 */
 	if (!is_projection_capable_path(path))
-		return (Path *) create_projection_path(root, rel, path, target);
+		return (Path *) create_projection_path(root, rel, path, target,
+											   false);
 
 	/*
 	 * We can just jam the desired tlist into the existing path, being sure to
@@ -2439,7 +2510,8 @@ apply_projection_to_path(PlannerInfo *root,
 				create_projection_path(root,
 									   gpath->subpath->parent,
 									   gpath->subpath,
-									   target);
+									   target,
+								   false);
 		}
 		else
 		{
@@ -2449,7 +2521,8 @@ apply_projection_to_path(PlannerInfo *root,
 				create_projection_path(root,
 									   gmpath->subpath->parent,
 									   gmpath->subpath,
-									   target);
+									   target,
+									   false);
 		}
 	}
 	else if (path->parallel_safe &&
@@ -2562,6 +2635,7 @@ create_sort_path(PlannerInfo *root,
 		subpath->parallel_safe;
 	pathnode->path.parallel_workers = subpath->parallel_workers;
 	pathnode->path.pathkeys = pathkeys;
+	pathnode->path.uniquekeys = subpath->uniquekeys;
 
 	pathnode->subpath = subpath;
 
@@ -2748,6 +2822,207 @@ create_agg_path(PlannerInfo *root,
 }
 
 /*
+ * Apply partial AGG_SORTED aggregation path to subpath if it's suitably
+ * sorted. ("partial" in the function name refers to AGGSPLIT_INITIAL_SERIAL
+ * strategy, as opposed to parallel processing.)
+ *
+ * first_call indicates whether the function is being called first time for
+ * given index --- since the target should not change, we can skip the check
+ * of sorting during subsequent calls.
+ *
+ * group_clauses, group_exprs and agg_exprs are pointers to lists we populate
+ * when called first time for particular index, and that user passes for
+ * subsequent calls.
+ *
+ * NULL is returned if sorting of subpath output is not suitable.
+ */
+AggPath *
+create_partial_agg_sorted_path(PlannerInfo *root, Path *subpath,
+							   bool first_call,
+							   List **group_clauses, List **group_exprs,
+							   List **agg_exprs, double input_rows,
+							   bool parallel)
+{
+	RelOptInfo *rel;
+	AggClauseCosts agg_costs;
+	double		dNumGroups;
+	AggPath    *result = NULL;
+
+	rel = subpath->parent;
+	Assert(rel->gpi != NULL);
+	Assert(rel->gpi->target != NULL);
+
+	if (subpath->pathkeys == NIL)
+		return NULL;
+
+	if (!grouping_is_sortable(root->parse->groupClause))
+		return NULL;
+
+	/* Add generic grouping expressions to the subpath if there are some. */
+	if (rel->gpi->group_exprs != NULL)
+		subpath = add_grouping_expressions_to_subpath(root, subpath,
+													  rel->gpi->group_exprs);
+
+	if (first_call)
+	{
+		ListCell   *lc1;
+		List	   *key_subset = NIL;
+
+		/*
+		 * Find all query pathkeys that our relation does affect.
+		 */
+		foreach(lc1, root->group_pathkeys)
+		{
+			PathKey    *gkey = castNode(PathKey, lfirst(lc1));
+			ListCell   *lc2;
+
+			foreach(lc2, subpath->pathkeys)
+			{
+				PathKey    *skey = castNode(PathKey, lfirst(lc2));
+
+				if (skey == gkey)
+				{
+					key_subset = lappend(key_subset, gkey);
+					break;
+				}
+			}
+		}
+
+		if (key_subset == NIL)
+			return NULL;
+
+		/* Check if AGG_SORTED is useful for the whole query.  */
+		if (!pathkeys_contained_in(key_subset, subpath->pathkeys))
+			return NULL;
+	}
+
+	if (first_call)
+		get_grouping_expressions(root, rel->gpi->target,
+								 rel->gpi->sortgroupclauses, group_clauses,
+								 group_exprs, agg_exprs);
+
+	MemSet(&agg_costs, 0, sizeof(AggClauseCosts));
+	Assert(*agg_exprs != NIL);
+	get_agg_clause_costs(root, (Node *) *agg_exprs, AGGSPLIT_INITIAL_SERIAL,
+						 &agg_costs);
+
+	Assert(*group_exprs != NIL);
+	dNumGroups = estimate_num_groups(root, *group_exprs, input_rows, NULL);
+
+	/* TODO HAVING qual. */
+	Assert(*group_clauses != NIL);
+	result = create_agg_path(root, rel, subpath, rel->gpi->target,
+							 AGG_SORTED, AGGSPLIT_INITIAL_SERIAL,
+							 *group_clauses, NIL, &agg_costs, dNumGroups);
+
+	/*
+	 * Check if there's a chance to avoid final aggregation.
+	 */
+	if (!parallel)
+		make_uniquekeys(root, (Path *) result);
+
+	return result;
+}
+
+/*
+ * Appy partial AGG_HASHED aggregation to subpath. ("partial" in the function
+ * name refers to AGGSPLIT_INITIAL_SERIAL strategy, as opposed to parallel
+ * processing.)
+ *
+ * Arguments have the same meaning as those of create_agg_sorted_path.
+ */
+AggPath *
+create_partial_agg_hashed_path(PlannerInfo *root, Path *subpath,
+							   bool first_call,
+							   List **group_clauses, List **group_exprs,
+							   List **agg_exprs, double input_rows,
+							   bool parallel)
+{
+	RelOptInfo *rel;
+	bool		can_hash;
+	AggClauseCosts agg_costs;
+	double		dNumGroups;
+	Size		hashaggtablesize;
+	Query	   *parse = root->parse;
+	AggPath    *result = NULL;
+
+	rel = subpath->parent;
+	Assert(rel->gpi != NULL);
+	Assert(rel->gpi->target != NULL);
+
+	/* Add generic grouping expressions to the subpath if there are some. */
+	if (rel->gpi->group_exprs != NULL)
+		subpath = add_grouping_expressions_to_subpath(root, subpath,
+													  rel->gpi->group_exprs);
+
+	if (first_call)
+	{
+		/*
+		 * Find one grouping clause per grouping column.
+		 *
+		 * All that create_agg_plan eventually needs of the clause is
+		 * tleSortGroupRef, so we don't have to care that the clause
+		 * expression might differ from texpr, in case texpr was derived from
+		 * EC.
+		 */
+		get_grouping_expressions(root, rel->gpi->target,
+								 rel->gpi->sortgroupclauses,
+								 group_clauses,
+								 group_exprs, agg_exprs);
+	}
+
+	MemSet(&agg_costs, 0, sizeof(AggClauseCosts));
+	Assert(*agg_exprs != NIL);
+	get_agg_clause_costs(root, (Node *) *agg_exprs, AGGSPLIT_INITIAL_SERIAL,
+						 &agg_costs);
+
+	can_hash = (parse->groupClause != NIL &&
+				parse->groupingSets == NIL &&
+				agg_costs.numOrderedAggs == 0 &&
+				grouping_is_hashable(parse->groupClause));
+
+	if (can_hash)
+	{
+		Assert(*group_exprs != NIL);
+		dNumGroups = estimate_num_groups(root, *group_exprs, input_rows,
+										 NULL);
+
+		hashaggtablesize = estimate_hashagg_tablesize(subpath, &agg_costs,
+													  dNumGroups);
+
+		if (hashaggtablesize < work_mem * 1024L)
+		{
+			/*
+			 * Create the partial aggregation path.
+			 */
+			Assert(*group_clauses != NIL);
+
+			result = create_agg_path(root, rel, subpath,
+									 rel->gpi->target,
+									 AGG_HASHED,
+									 AGGSPLIT_INITIAL_SERIAL,
+									 *group_clauses, NIL,
+									 &agg_costs,
+									 dNumGroups);
+
+			/*
+			 * The agg path should require no fewer parameters than the plain
+			 * one.
+			 */
+			result->path.param_info = subpath->param_info;
+		}
+	}
+
+	/*
+	 * Check if there's a chance to avoid final aggregation.
+	 */
+	if (result != NULL && !parallel)
+		make_uniquekeys(root, (Path *) result);
+
+	return result;
+}
+
+/*
  * create_groupingsets_path
  *	  Creates a pathnode that represents performing GROUPING SETS aggregation
  *
